--
-- Specialization for pendling front axle (not damping)
-- date 22.04.2012
--
-- author: fendtfahrer(95)
-- thx @ knagsted for some code parts of his scripts
--
FrontAxle = {}

function FrontAxle.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function FrontAxle:load(xmlFile)	
	
	self.frontAxle = {};
	self.frontAxle.rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#rotNode"));
	
	
	self.numAnimatedWheels = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.animatedWheels#count"), 0);
	self.animatedWheel = {};
    for i=1, self.numAnimatedWheels do
        local objname = string.format("vehicle.animatedWheels.wheel" .. "%d", i);
		self.animatedWheel[i] = {};
        self.animatedWheel[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		self.animatedWheel[i].wheel = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#wheelIndex"));
		self.animatedWheel[i].fenderAttach = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#fenderAttach"));
    end;

end;
      
function FrontAxle:delete()
end;

function FrontAxle:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function FrontAxle:keyEvent(unicode, sym, modifier, isDown)
end;

function FrontAxle:update(dt)
	
	if self.frontAxle.rotNode ~= nil and self.wheels[1].repr ~= nil and self.wheels[2].repr ~= nil then
		local ax, ay, az = getWorldTranslation(self.wheels[1].repr);
        local bx, by, bz = getWorldTranslation(self.wheels[2].repr);	
			
		local x, y, z = worldDirectionToLocal(getParent(self.frontAxle.rotNode), bx-ax, by-ay, bz-az);		
        setDirection(self.frontAxle.rotNode, x, y, z, 1, 0, 1);
		local x2,y2,z2 = getRotation(self.frontAxle.rotNode);
		setRotation(self.frontAxle.rotNode,x2 - 1.571,y2,z2 + 1.571);
	end;
	
	for i=1, self.numAnimatedWheels do
		if self.wheels[i].repr ~= nil then
			local x,y,z = getRotation(self.wheels[i].driveNode);
			local x2,y2,z2 = getRotation(self.wheels[i].repr);
			setRotation(self.animatedWheel[i].wheel, x,y,z);
			setRotation(self.animatedWheel[i].rotNode, x2,y2,z2);
		end;
	end;		
	
	if self.animatedWheel[1].fenderAttach ~= nil and self.animatedWheel[2].fenderAttach ~= nil then
		local x, y, z = getRotation(self.animatedWheel[1].fenderAttach);
		local x2, y2, z2 = getRotation(self.animatedWheel[2].fenderAttach);
		
		setRotation(self.animatedWheel[1].fenderAttach, x, y, z, 0, 1, 0);
		setRotation(self.animatedWheel[2].fenderAttach, x2, y2, z2, 0, 1, 0);
	end;	
end;

function FrontAxle:draw()
	
end;
